#ifndef lint
static char pcap_sccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";
#endif
#define YYBYACC 1
#line 2 "/export/home/gray/ipacct/libpcap/./grammar.y"
/*
 * Copyright (c) 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that: (1) source code distributions
 * retain the above copyright notice and this paragraph in its entirety, (2)
 * distributions including binary code include the above copyright notice and
 * this paragraph in its entirety in the documentation or other materials
 * provided with the distribution, and (3) all advertising materials mentioning
 * features or use of this software display the following acknowledgement:
 * ``This product includes software developed by the University of California,
 * Lawrence Berkeley Laboratory and its contributors.'' Neither the name of
 * the University nor the names of its contributors may be used to endorse
 * or promote products derived from this software without specific prior
 * written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 */
#ifndef lint
static const char rcsid[] =
    "@(#) $Header: /home/gray/cvsroot/ipacct/libpcap/grammar.c,v 1.1.1.1 2001/05/31 13:40:53 gray Exp $ (LBL)";
#endif

#if defined(HAVE_CONFIG_H)
# include <config.h>
#endif

#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>

#if __STDC__
struct mbuf;
struct rtentry;
#endif

#include <net/if.h>

#include <netinet/in.h>
#include <netinet/if_ether.h>

#include <stdio.h>

#include <pcap-int.h>

#include <gencode.h>
#include <pcap-namedb.h>

#include <gnuc.h>
#ifdef HAVE_OS_PROTO_H
#include <os-proto.h>
#endif

#define QSET(q, p, d, a) (q).proto = (p),\
			 (q).dir = (d),\
			 (q).addr = (a)

int n_errors = 0;

static struct qual qerr = { Q_UNDEF, Q_UNDEF, Q_UNDEF, Q_UNDEF };

static void
pcap_error(char *msg)
{
	++n_errors;
	bpf_error("%s", msg);
	/* NOTREACHED */
}

#line 76 "/export/home/gray/ipacct/libpcap/./grammar.y"
typedef union {
	int i;
	bpf_u_int32 h;
	u_char *e;
	char *s;
	struct stmt *stmt;
	struct arth *a;
	struct {
		struct qual q;
		struct block *b;
	} blk;
	struct block *rblk;
} YYSTYPE;
#line 93 "grammar.c"
#define DST 257
#define SRC 258
#define HOST 259
#define GATEWAY 260
#define NET 261
#define MASK 262
#define PORT 263
#define LESS 264
#define GREATER 265
#define PROTO 266
#define BYTE 267
#define ARP 268
#define RARP 269
#define IP 270
#define TCP 271
#define UDP 272
#define ICMP 273
#define IGMP 274
#define IGRP 275
#define ATALK 276
#define DECNET 277
#define LAT 278
#define SCA 279
#define MOPRC 280
#define MOPDL 281
#define TK_BROADCAST 282
#define TK_MULTICAST 283
#define NUM 284
#define INBOUND 285
#define OUTBOUND 286
#define LINK 287
#define GEQ 288
#define LEQ 289
#define NEQ 290
#define ID 291
#define EID 292
#define HID 293
#define LSH 294
#define RSH 295
#define LEN 296
#define OR 297
#define AND 298
#define UMINUS 299
#define YYERRCODE 256
short pcap_lhs[] = {                                        -1,
    0,    0,   24,    1,    1,    1,    1,    1,   20,   21,
    2,    2,    2,    3,    3,    3,    3,    3,    3,   23,
   22,    4,    4,    4,    7,    7,    5,    5,    8,    8,
    8,    8,    8,    6,    6,    6,    6,    6,    6,    9,
    9,   10,   10,   10,   10,   10,   10,   11,   11,   11,
   12,   16,   16,   16,   16,   16,   16,   16,   16,   16,
   16,   16,   16,   16,   16,   16,   25,   25,   25,   25,
   25,   25,   25,   18,   18,   18,   19,   19,   19,   13,
   13,   14,   14,   14,   14,   14,   14,   14,   14,   14,
   14,   14,   14,   14,   15,   15,   15,   15,   15,   17,
   17,
};
short pcap_len[] = {                                         2,
    2,    1,    0,    1,    3,    3,    3,    3,    1,    1,
    1,    1,    3,    1,    3,    3,    1,    1,    2,    1,
    1,    1,    3,    3,    1,    1,    1,    2,    3,    2,
    2,    2,    2,    2,    3,    1,    3,    3,    1,    1,
    0,    1,    1,    3,    3,    3,    3,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    2,    2,    2,    2,
    4,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    4,    6,    3,    3,    3,    3,    3,    3,    3,
    3,    2,    3,    1,    1,    1,    1,    1,    1,    1,
    3,
};
short pcap_defred[] = {                                      3,
    0,    0,    0,    0,    0,   54,   55,   53,   56,   57,
   58,   59,   60,   61,   62,   63,   64,   66,   65,  100,
   72,   73,   52,   94,   20,    0,   21,    0,    4,   27,
    0,    0,    0,   81,    0,   80,    0,    0,   39,   69,
   70,    0,   92,    0,    0,   10,    9,    0,    0,   14,
   18,    0,   34,   11,   12,    0,    0,    0,    0,   48,
   51,   49,   50,   32,   67,   68,    0,   31,   33,   75,
   77,   79,    0,    0,    0,    0,    0,    0,    0,    0,
   74,   76,   78,    0,    0,    0,    0,    0,    0,   28,
   96,   95,   98,   99,   97,    0,    0,    6,    5,    0,
    0,    0,    8,    7,    0,    0,   22,    0,    0,    0,
    0,   19,    0,    0,    0,    0,   29,    0,    0,    0,
    0,    0,    0,   86,   87,    0,    0,    0,   35,   93,
  101,   71,    0,   16,   15,   13,    0,    0,    0,   45,
   47,   44,   46,   82,    0,   23,   24,    0,   83,
};
short pcap_dgoto[] = {                                       1,
   87,  112,   54,  108,   29,   30,  109,   31,   32,   67,
   68,   69,   33,   34,   96,   44,   36,   84,   85,   48,
   49,   45,   57,    2,   39,
};
short pcap_sindex[] = {                                      0,
    0,  -29, -261, -249, -243,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  288,    0, -290,    0,    0,
  -12,  270,  335,    0,  -42,    0,  -29,  -29,    0,    0,
    0,   -2,    0,  -42,  288,    0,    0,  143,  143,    0,
    0,  -44,    0,    0,    0,  -12,  -12, -264, -221,    0,
    0,    0,    0,    0,    0,    0, -145,    0,    0,    0,
    0,    0,  288,  288,  288,  288,  288,  288,  288,  288,
    0,    0,    0,  288,  288,  288,  -22,   11,   13,    0,
    0,    0,    0,    0,    0, -219,  459,    0,    0,    0,
  143,  143,    0,    0, -225, -199,    0,   49, -290,   13,
  -31,    0, -155, -148, -142, -140,    0,  -18,  -18,  -25,
  137,  -37,  -37,    0,    0,  459,  459,  453,    0,    0,
    0,    0,   13,    0,    0,    0,  -12,  -12,   13,    0,
    0,    0,    0,    0, -161,    0,    0,   36,    0,
};
short pcap_rindex[] = {                                      0,
    0,    2,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  132,    0,    0,
    0,    0,    0,    0,  108,    0,  401,  401,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  401,  401,    0,
    0,    6,    0,    0,    0,    0,    0,  193,  231,    0,
    0,    0,    0,    0,    0,    0,   60,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  419,  427,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,
  401,  401,    0,    0,    0,    0,    0, -218,    0, -215,
    0,    0,    0,    0,    0,    0,    0,   37,   51,   96,
   66,   12,   26,    0,    0,   15,   40,    0,    0,    0,
    0,    0,  153,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
short pcap_gindex[] = {                                      0,
  131,  -17,  -56,    0,   53,    0,    0,    0,    0,    0,
   67,    0,  561,   -7,    0,  104,  555,    0,    0,   29,
   30,  542,  129,    0,    0,
};
#define YYTABLESIZE 754
short pcap_table[] = {                                     107,
   12,    2,  106,   25,   79,   17,   46,   47,   27,   80,
   27,   84,   76,   53,   37,   26,   79,   77,  129,   78,
   25,   80,   40,   79,   77,   85,   78,   27,   80,   88,
   98,  103,  113,  114,   41,   92,   90,   88,   80,   38,
   42,   12,   80,   80,  107,   80,   17,   80,   86,   84,
   91,  130,   84,  131,   84,   37,   84,   95,   94,   93,
   80,   80,   80,   85,  132,   88,   85,  134,   85,   84,
   85,   84,   84,   84,   90,  115,  116,   90,   26,   26,
   38,   25,   25,   85,  135,   85,   85,   85,   91,  136,
   90,   91,   30,   88,   90,   89,   90,   90,   90,   30,
   99,  104,  140,   88,   84,   35,   88,   36,   91,  141,
   91,   91,   91,   60,  142,   62,  143,   63,   85,  146,
  147,   91,  148,   88,   80,   88,   88,   88,  149,   90,
   38,    1,   28,  117,    0,   84,   89,  137,  138,    0,
   35,   35,    0,   91,    0,    0,    0,    0,   36,   85,
    0,   35,   35,   89,   90,   89,   89,   89,   88,    0,
   90,    0,    0,    0,    0,   38,   38,    0,    0,    0,
    0,    0,    0,    0,   91,   25,  102,  102,   79,   77,
    0,   78,   27,   80,    0,    0,    0,   26,   89,   88,
   80,    0,    0,    0,   80,   80,    0,   80,    0,   80,
    0,    0,    0,    0,   35,   35,    0,    0,    0,    0,
    0,    0,   80,   80,   80,    0,    0,  105,    0,   89,
    0,    0,    0,    0,    0,   43,    0,    0,    0,  102,
  102,    0,   43,    0,    3,    4,    0,    5,    6,    7,
    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,
   18,   19,   20,    0,   20,   21,   22,   23,   41,   41,
   41,   41,   41,   42,   41,    0,   24,   41,   73,   74,
   42,   20,    0,    0,   46,   47,   80,    0,   50,   51,
   52,    0,    0,   41,   41,    0,    0,    0,   80,   80,
   80,    0,    0,    0,   80,   80,    0,   12,   12,   84,
   84,   84,   17,   17,    0,   84,   84,    0,   84,   84,
    0,   37,   37,   85,   85,   85,    0,    0,    0,   85,
   85,    0,   85,   85,   90,   90,   90,   27,    0,    0,
   90,   90,   26,   90,   90,    0,   38,   38,   91,   91,
   91,    0,    0,   30,   91,   91,    0,   91,   91,    0,
   30,   30,   30,   88,   88,   88,    0,    0,    0,    0,
    0,    0,   88,   88,   40,   40,   40,   40,   40,    0,
   40,    0,   76,   40,    0,    0,   79,   77,    0,   78,
    0,   80,    0,   89,   89,   89,    0,    0,    0,   40,
   40,    0,   89,   89,   83,   82,   81,    0,    0,    0,
    0,    0,    0,    0,   36,   36,    3,    4,    0,    5,
    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,
   16,   17,   18,   19,    0,    0,   20,   21,   22,   23,
   73,   74,    0,   50,   51,   52,    0,    0,   24,    0,
   80,   80,   80,    0,    0,    0,   80,   80,    0,   25,
   25,   43,    0,   43,    0,   43,   81,    0,   75,    0,
   81,   81,    0,   81,   80,   81,    0,    0,   80,   80,
    0,   80,    0,   80,    0,    0,   43,    0,   81,   81,
   81,    0,    0,   43,   43,   43,   80,   80,   80,   42,
   76,   42,    0,   42,   79,   77,   76,   78,    0,   80,
   79,   77,    0,   78,    0,   80,    0,    0,    0,    0,
  145,    0,    0,    0,   42,    0,    0,    0,    0,    0,
    0,   42,   42,   42,    0,    0,   58,   59,   60,   61,
   62,    0,   63,    0,    0,   64,    0,    0,    0,    0,
    0,    0,   81,   37,    0,  144,    0,    0,    0,    0,
   80,   65,   66,    0,    0,    6,    7,    8,    9,   10,
   11,   12,   13,   14,   15,   16,   17,   18,   19,    0,
    0,   20,   56,    0,   23,    0,   75,    0,   37,   37,
    0,    0,   75,   24,    0,   55,   43,    0,    0,  101,
  101,   89,    0,    0,    0,    0,    0,  111,   56,   89,
    0,    0,  100,  100,    0,   97,    0,    0,    0,    0,
  110,   55,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   70,   71,   72,    0,    0,    0,   73,   74,
    0,    0,    0,  118,  119,  120,  121,  122,  123,  124,
  125,    0,   37,  101,  126,  127,  128,    0,    0,    0,
    0,    0,  111,    0,    0,  133,  100,   41,   41,   41,
   41,   41,    0,   41,    0,  139,   41,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   56,   56,
    0,    0,   41,   41,    0,    0,    0,    0,    0,    0,
    0,   55,   55,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   81,   81,   81,    0,
    0,    0,   81,   81,   80,   80,   80,    0,    0,    0,
   80,   80,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   73,   74,    0,    0,
    0,    0,   73,   74,
};
short pcap_check[] = {                                      56,
    0,    0,   47,   33,   42,    0,  297,  298,   40,   47,
   40,    0,   38,   31,    0,   45,   42,   43,   41,   45,
   33,   47,  284,   42,   43,    0,   45,   40,   47,   37,
   48,   49,  297,  298,  284,   38,    0,   45,   38,    0,
  284,   41,   42,   43,  101,   45,   41,   47,   91,   38,
    0,   41,   41,   41,   43,   41,   45,   60,   61,   62,
   60,   61,   62,   38,  284,    0,   41,  293,   43,   58,
   45,   60,   61,   62,   38,  297,  298,   41,  297,  298,
   41,  297,  298,   58,  284,   60,   61,   62,   38,   41,
   38,   41,   33,  101,   58,    0,   60,   61,   62,   40,
   48,   49,  258,   38,   93,    2,   41,    0,   58,  258,
   60,   61,   62,  259,  257,  261,  257,  263,   93,  137,
  138,  124,  284,   58,  124,   60,   61,   62,   93,   93,
    2,    0,    2,   67,   -1,  124,   41,  109,  109,   -1,
   37,   38,   -1,   93,   -1,   -1,   -1,   -1,   41,  124,
   -1,   48,   49,   58,  102,   60,   61,   62,   93,   -1,
  124,   -1,   -1,   -1,   -1,   37,   38,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  124,   33,   48,   49,   42,   43,
   -1,   45,   40,   47,   -1,   -1,   -1,   45,   93,  124,
   38,   -1,   -1,   -1,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,  101,  102,   -1,   -1,   -1,   -1,
   -1,   -1,   60,   61,   62,   -1,   -1,  262,   -1,  124,
   -1,   -1,   -1,   -1,   -1,   33,   -1,   -1,   -1,  101,
  102,   -1,   40,   -1,  264,  265,   -1,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  284,   -1,  284,  285,  286,  287,  257,  258,
  259,  260,  261,   33,  263,   -1,  296,  266,  294,  295,
   40,  284,   -1,   -1,  297,  298,  124,   -1,  291,  292,
  293,   -1,   -1,  282,  283,   -1,   -1,   -1,  288,  289,
  290,   -1,   -1,   -1,  294,  295,   -1,  297,  298,  288,
  289,  290,  297,  298,   -1,  294,  295,   -1,  297,  298,
   -1,  297,  298,  288,  289,  290,   -1,   -1,   -1,  294,
  295,   -1,  297,  298,  288,  289,  290,   40,   -1,   -1,
  294,  295,   45,  297,  298,   -1,  297,  298,  288,  289,
  290,   -1,   -1,  284,  294,  295,   -1,  297,  298,   -1,
  291,  292,  293,  288,  289,  290,   -1,   -1,   -1,   -1,
   -1,   -1,  297,  298,  257,  258,  259,  260,  261,   -1,
  263,   -1,   38,  266,   -1,   -1,   42,   43,   -1,   45,
   -1,   47,   -1,  288,  289,  290,   -1,   -1,   -1,  282,
  283,   -1,  297,  298,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  297,  298,  264,  265,   -1,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,   -1,   -1,  284,  285,  286,  287,
  294,  295,   -1,  291,  292,  293,   -1,   -1,  296,   -1,
  288,  289,  290,   -1,   -1,   -1,  294,  295,   -1,  297,
  298,  259,   -1,  261,   -1,  263,   38,   -1,  124,   -1,
   42,   43,   -1,   45,   38,   47,   -1,   -1,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,  284,   -1,   60,   61,
   62,   -1,   -1,  291,  292,  293,   60,   61,   62,  259,
   38,  261,   -1,  263,   42,   43,   38,   45,   -1,   47,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   58,   -1,   -1,   -1,  284,   -1,   -1,   -1,   -1,   -1,
   -1,  291,  292,  293,   -1,   -1,  257,  258,  259,  260,
  261,   -1,  263,   -1,   -1,  266,   -1,   -1,   -1,   -1,
   -1,   -1,  124,    2,   -1,   93,   -1,   -1,   -1,   -1,
  124,  282,  283,   -1,   -1,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,   -1,
   -1,  284,   31,   -1,  287,   -1,  124,   -1,   37,   38,
   -1,   -1,  124,  296,   -1,   31,   26,   -1,   -1,   48,
   49,   37,   -1,   -1,   -1,   -1,   -1,   56,   57,   45,
   -1,   -1,   48,   49,   -1,   45,   -1,   -1,   -1,   -1,
   56,   57,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  288,  289,  290,   -1,   -1,   -1,  294,  295,
   -1,   -1,   -1,   73,   74,   75,   76,   77,   78,   79,
   80,   -1,  101,  102,   84,   85,   86,   -1,   -1,   -1,
   -1,   -1,  111,   -1,   -1,  101,  102,  257,  258,  259,
  260,  261,   -1,  263,   -1,  111,  266,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  137,  138,
   -1,   -1,  282,  283,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  137,  138,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  288,  289,  290,   -1,
   -1,   -1,  294,  295,  288,  289,  290,   -1,   -1,   -1,
  294,  295,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  294,  295,   -1,   -1,
   -1,   -1,  294,  295,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 299
#if YYDEBUG
char *pcap_name[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,0,"'&'",0,"'('","')'","'*'","'+'",0,"'-'",0,"'/'",0,0,0,0,0,0,0,0,0,
0,"':'",0,"'<'","'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'|'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"DST","SRC","HOST","GATEWAY","NET","MASK","PORT",
"LESS","GREATER","PROTO","BYTE","ARP","RARP","IP","TCP","UDP","ICMP","IGMP",
"IGRP","ATALK","DECNET","LAT","SCA","MOPRC","MOPDL","TK_BROADCAST",
"TK_MULTICAST","NUM","INBOUND","OUTBOUND","LINK","GEQ","LEQ","NEQ","ID","EID",
"HID","LSH","RSH","LEN","OR","AND","UMINUS",
};
char *pcap_rule[] = {
"$accept : prog",
"prog : null expr",
"prog : null",
"null :",
"expr : term",
"expr : expr and term",
"expr : expr and id",
"expr : expr or term",
"expr : expr or id",
"and : AND",
"or : OR",
"id : nid",
"id : pnum",
"id : paren pid ')'",
"nid : ID",
"nid : HID '/' NUM",
"nid : HID MASK HID",
"nid : HID",
"nid : EID",
"nid : not id",
"not : '!'",
"paren : '('",
"pid : nid",
"pid : qid and id",
"pid : qid or id",
"qid : pnum",
"qid : pid",
"term : rterm",
"term : not term",
"head : pqual dqual aqual",
"head : pqual dqual",
"head : pqual aqual",
"head : pqual PROTO",
"head : pqual ndaqual",
"rterm : head id",
"rterm : paren expr ')'",
"rterm : pname",
"rterm : arth relop arth",
"rterm : arth irelop arth",
"rterm : other",
"pqual : pname",
"pqual :",
"dqual : SRC",
"dqual : DST",
"dqual : SRC OR DST",
"dqual : DST OR SRC",
"dqual : SRC AND DST",
"dqual : DST AND SRC",
"aqual : HOST",
"aqual : NET",
"aqual : PORT",
"ndaqual : GATEWAY",
"pname : LINK",
"pname : IP",
"pname : ARP",
"pname : RARP",
"pname : TCP",
"pname : UDP",
"pname : ICMP",
"pname : IGMP",
"pname : IGRP",
"pname : ATALK",
"pname : DECNET",
"pname : LAT",
"pname : SCA",
"pname : MOPDL",
"pname : MOPRC",
"other : pqual TK_BROADCAST",
"other : pqual TK_MULTICAST",
"other : LESS NUM",
"other : GREATER NUM",
"other : BYTE NUM byteop NUM",
"other : INBOUND",
"other : OUTBOUND",
"relop : '>'",
"relop : GEQ",
"relop : '='",
"irelop : LEQ",
"irelop : '<'",
"irelop : NEQ",
"arth : pnum",
"arth : narth",
"narth : pname '[' arth ']'",
"narth : pname '[' arth ':' NUM ']'",
"narth : arth '+' arth",
"narth : arth '-' arth",
"narth : arth '*' arth",
"narth : arth '/' arth",
"narth : arth '&' arth",
"narth : arth '|' arth",
"narth : arth LSH arth",
"narth : arth RSH arth",
"narth : '-' arth",
"narth : paren narth ')'",
"narth : LEN",
"byteop : '&'",
"byteop : '|'",
"byteop : '<'",
"byteop : '>'",
"byteop : '='",
"pnum : NUM",
"pnum : paren pnum ')'",
};
#endif
#define pcap_clearin (pcap_char=(-1))
#define pcap_errok (pcap_errflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int pcap_debug;
int pcap_nerrs;
int pcap_errflag;
int pcap_char;
short *pcap_ssp;
YYSTYPE *pcap_vsp;
YYSTYPE pcap_val;
YYSTYPE pcap_lval;
short pcap_ss[YYSTACKSIZE];
YYSTYPE pcap_vs[YYSTACKSIZE];
#define pcap_stacksize YYSTACKSIZE
#define YYABORT goto pcap_abort
#define YYACCEPT goto pcap_accept
#define YYERROR goto pcap_errlab
int
pcap_parse()
{
    register int pcap_m, pcap_n, pcap_state;
#if YYDEBUG
    register char *pcap_s;
    extern char *getenv();

    if (pcap_s = getenv("YYDEBUG"))
    {
        pcap_n = *pcap_s;
        if (pcap_n >= '0' && pcap_n <= '9')
            pcap_debug = pcap_n - '0';
    }
#endif

    pcap_nerrs = 0;
    pcap_errflag = 0;
    pcap_char = (-1);

    pcap_ssp = pcap_ss;
    pcap_vsp = pcap_vs;
    *pcap_ssp = pcap_state = 0;

pcap_loop:
    if (pcap_n = pcap_defred[pcap_state]) goto pcap_reduce;
    if (pcap_char < 0)
    {
        if ((pcap_char = pcap_lex()) < 0) pcap_char = 0;
#if YYDEBUG
        if (pcap_debug)
        {
            pcap_s = 0;
            if (pcap_char <= YYMAXTOKEN) pcap_s = pcap_name[pcap_char];
            if (!pcap_s) pcap_s = "illegal-symbol";
            printf("pcap_debug: state %d, reading %d (%s)\n", pcap_state,
                    pcap_char, pcap_s);
        }
#endif
    }
    if ((pcap_n = pcap_sindex[pcap_state]) && (pcap_n += pcap_char) >= 0 &&
            pcap_n <= YYTABLESIZE && pcap_check[pcap_n] == pcap_char)
    {
#if YYDEBUG
        if (pcap_debug)
            printf("pcap_debug: state %d, shifting to state %d\n",
                    pcap_state, pcap_table[pcap_n]);
#endif
        if (pcap_ssp >= pcap_ss + pcap_stacksize - 1)
        {
            goto pcap_overflow;
        }
        *++pcap_ssp = pcap_state = pcap_table[pcap_n];
        *++pcap_vsp = pcap_lval;
        pcap_char = (-1);
        if (pcap_errflag > 0)  --pcap_errflag;
        goto pcap_loop;
    }
    if ((pcap_n = pcap_rindex[pcap_state]) && (pcap_n += pcap_char) >= 0 &&
            pcap_n <= YYTABLESIZE && pcap_check[pcap_n] == pcap_char)
    {
        pcap_n = pcap_table[pcap_n];
        goto pcap_reduce;
    }
    if (pcap_errflag) goto pcap_inrecovery;
#ifdef lint
    goto pcap_newerror;
#endif
pcap_newerror:
    pcap_error("syntax error");
#ifdef lint
    goto pcap_errlab;
#endif
pcap_errlab:
    ++pcap_nerrs;
pcap_inrecovery:
    if (pcap_errflag < 3)
    {
        pcap_errflag = 3;
        for (;;)
        {
            if ((pcap_n = pcap_sindex[*pcap_ssp]) && (pcap_n += YYERRCODE) >= 0 &&
                    pcap_n <= YYTABLESIZE && pcap_check[pcap_n] == YYERRCODE)
            {
#if YYDEBUG
                if (pcap_debug)
                    printf("pcap_debug: state %d, error recovery shifting\
 to state %d\n", *pcap_ssp, pcap_table[pcap_n]);
#endif
                if (pcap_ssp >= pcap_ss + pcap_stacksize - 1)
                {
                    goto pcap_overflow;
                }
                *++pcap_ssp = pcap_state = pcap_table[pcap_n];
                *++pcap_vsp = pcap_lval;
                goto pcap_loop;
            }
            else
            {
#if YYDEBUG
                if (pcap_debug)
                    printf("pcap_debug: error recovery discarding state %d\n",
                            *pcap_ssp);
#endif
                if (pcap_ssp <= pcap_ss) goto pcap_abort;
                --pcap_ssp;
                --pcap_vsp;
            }
        }
    }
    else
    {
        if (pcap_char == 0) goto pcap_abort;
#if YYDEBUG
        if (pcap_debug)
        {
            pcap_s = 0;
            if (pcap_char <= YYMAXTOKEN) pcap_s = pcap_name[pcap_char];
            if (!pcap_s) pcap_s = "illegal-symbol";
            printf("pcap_debug: state %d, error recovery discards token %d (%s)\n",
                    pcap_state, pcap_char, pcap_s);
        }
#endif
        pcap_char = (-1);
        goto pcap_loop;
    }
pcap_reduce:
#if YYDEBUG
    if (pcap_debug)
        printf("pcap_debug: state %d, reducing by rule %d (%s)\n",
                pcap_state, pcap_n, pcap_rule[pcap_n]);
#endif
    pcap_m = pcap_len[pcap_n];
    pcap_val = pcap_vsp[1-pcap_m];
    switch (pcap_n)
    {
case 1:
#line 125 "/export/home/gray/ipacct/libpcap/./grammar.y"
{
	finish_parse(pcap_vsp[0].blk.b);
}
break;
case 3:
#line 130 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk.q = qerr; }
break;
case 5:
#line 133 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ gen_and(pcap_vsp[-2].blk.b, pcap_vsp[0].blk.b); pcap_val.blk = pcap_vsp[0].blk; }
break;
case 6:
#line 134 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ gen_and(pcap_vsp[-2].blk.b, pcap_vsp[0].blk.b); pcap_val.blk = pcap_vsp[0].blk; }
break;
case 7:
#line 135 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ gen_or(pcap_vsp[-2].blk.b, pcap_vsp[0].blk.b); pcap_val.blk = pcap_vsp[0].blk; }
break;
case 8:
#line 136 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ gen_or(pcap_vsp[-2].blk.b, pcap_vsp[0].blk.b); pcap_val.blk = pcap_vsp[0].blk; }
break;
case 9:
#line 138 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk = pcap_vsp[-1].blk; }
break;
case 10:
#line 140 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk = pcap_vsp[-1].blk; }
break;
case 12:
#line 143 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk.b = gen_ncode(NULL, (bpf_u_int32)pcap_vsp[0].i,
						   pcap_val.blk.q = pcap_vsp[-1].blk.q); }
break;
case 13:
#line 145 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk = pcap_vsp[-1].blk; }
break;
case 14:
#line 147 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk.b = gen_scode(pcap_vsp[0].s, pcap_val.blk.q = pcap_vsp[-1].blk.q); }
break;
case 15:
#line 148 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk.b = gen_mcode(pcap_vsp[-2].s, NULL, pcap_vsp[0].i,
				    pcap_val.blk.q = pcap_vsp[-3].blk.q); }
break;
case 16:
#line 150 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk.b = gen_mcode(pcap_vsp[-2].s, pcap_vsp[0].s, 0,
				    pcap_val.blk.q = pcap_vsp[-3].blk.q); }
break;
case 17:
#line 152 "/export/home/gray/ipacct/libpcap/./grammar.y"
{
				  /* Decide how to parse HID based on proto */
				  pcap_val.blk.q = pcap_vsp[-1].blk.q;
				  switch (pcap_val.blk.q.proto) {
				  case Q_DECNET:
					pcap_val.blk.b = gen_ncode(pcap_vsp[0].s, 0, pcap_val.blk.q);
					break;
				  default:
					pcap_val.blk.b = gen_ncode(pcap_vsp[0].s, 0, pcap_val.blk.q);
					break;
				  }
				}
break;
case 18:
#line 164 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk.b = gen_ecode(pcap_vsp[0].e, pcap_val.blk.q = pcap_vsp[-1].blk.q); }
break;
case 19:
#line 165 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ gen_not(pcap_vsp[0].blk.b); pcap_val.blk = pcap_vsp[0].blk; }
break;
case 20:
#line 167 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk = pcap_vsp[-1].blk; }
break;
case 21:
#line 169 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk = pcap_vsp[-1].blk; }
break;
case 23:
#line 172 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ gen_and(pcap_vsp[-2].blk.b, pcap_vsp[0].blk.b); pcap_val.blk = pcap_vsp[0].blk; }
break;
case 24:
#line 173 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ gen_or(pcap_vsp[-2].blk.b, pcap_vsp[0].blk.b); pcap_val.blk = pcap_vsp[0].blk; }
break;
case 25:
#line 175 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk.b = gen_ncode(NULL, (bpf_u_int32)pcap_vsp[0].i,
						   pcap_val.blk.q = pcap_vsp[-1].blk.q); }
break;
case 28:
#line 180 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ gen_not(pcap_vsp[0].blk.b); pcap_val.blk = pcap_vsp[0].blk; }
break;
case 29:
#line 182 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ QSET(pcap_val.blk.q, pcap_vsp[-2].i, pcap_vsp[-1].i, pcap_vsp[0].i); }
break;
case 30:
#line 183 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ QSET(pcap_val.blk.q, pcap_vsp[-1].i, pcap_vsp[0].i, Q_DEFAULT); }
break;
case 31:
#line 184 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ QSET(pcap_val.blk.q, pcap_vsp[-1].i, Q_DEFAULT, pcap_vsp[0].i); }
break;
case 32:
#line 185 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ QSET(pcap_val.blk.q, pcap_vsp[-1].i, Q_DEFAULT, Q_PROTO); }
break;
case 33:
#line 186 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ QSET(pcap_val.blk.q, pcap_vsp[-1].i, Q_DEFAULT, pcap_vsp[0].i); }
break;
case 34:
#line 188 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk = pcap_vsp[0].blk; }
break;
case 35:
#line 189 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk.b = pcap_vsp[-1].blk.b; pcap_val.blk.q = pcap_vsp[-2].blk.q; }
break;
case 36:
#line 190 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk.b = gen_proto_abbrev(pcap_vsp[0].i); pcap_val.blk.q = qerr; }
break;
case 37:
#line 191 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk.b = gen_relation(pcap_vsp[-1].i, pcap_vsp[-2].a, pcap_vsp[0].a, 0);
				  pcap_val.blk.q = qerr; }
break;
case 38:
#line 193 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk.b = gen_relation(pcap_vsp[-1].i, pcap_vsp[-2].a, pcap_vsp[0].a, 1);
				  pcap_val.blk.q = qerr; }
break;
case 39:
#line 195 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.blk.b = pcap_vsp[0].rblk; pcap_val.blk.q = qerr; }
break;
case 41:
#line 199 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_DEFAULT; }
break;
case 42:
#line 202 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_SRC; }
break;
case 43:
#line 203 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_DST; }
break;
case 44:
#line 204 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_OR; }
break;
case 45:
#line 205 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_OR; }
break;
case 46:
#line 206 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_AND; }
break;
case 47:
#line 207 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_AND; }
break;
case 48:
#line 210 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_HOST; }
break;
case 49:
#line 211 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_NET; }
break;
case 50:
#line 212 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_PORT; }
break;
case 51:
#line 215 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_GATEWAY; }
break;
case 52:
#line 217 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_LINK; }
break;
case 53:
#line 218 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_IP; }
break;
case 54:
#line 219 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_ARP; }
break;
case 55:
#line 220 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_RARP; }
break;
case 56:
#line 221 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_TCP; }
break;
case 57:
#line 222 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_UDP; }
break;
case 58:
#line 223 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_ICMP; }
break;
case 59:
#line 224 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_IGMP; }
break;
case 60:
#line 225 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_IGRP; }
break;
case 61:
#line 226 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_ATALK; }
break;
case 62:
#line 227 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_DECNET; }
break;
case 63:
#line 228 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_LAT; }
break;
case 64:
#line 229 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_SCA; }
break;
case 65:
#line 230 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_MOPDL; }
break;
case 66:
#line 231 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = Q_MOPRC; }
break;
case 67:
#line 233 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.rblk = gen_broadcast(pcap_vsp[-1].i); }
break;
case 68:
#line 234 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.rblk = gen_multicast(pcap_vsp[-1].i); }
break;
case 69:
#line 235 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.rblk = gen_less(pcap_vsp[0].i); }
break;
case 70:
#line 236 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.rblk = gen_greater(pcap_vsp[0].i); }
break;
case 71:
#line 237 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.rblk = gen_byteop(pcap_vsp[-1].i, pcap_vsp[-2].i, pcap_vsp[0].i); }
break;
case 72:
#line 238 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.rblk = gen_inbound(0); }
break;
case 73:
#line 239 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.rblk = gen_inbound(1); }
break;
case 74:
#line 241 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = BPF_JGT; }
break;
case 75:
#line 242 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = BPF_JGE; }
break;
case 76:
#line 243 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = BPF_JEQ; }
break;
case 77:
#line 245 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = BPF_JGT; }
break;
case 78:
#line 246 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = BPF_JGE; }
break;
case 79:
#line 247 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = BPF_JEQ; }
break;
case 80:
#line 249 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.a = gen_loadi(pcap_vsp[0].i); }
break;
case 82:
#line 252 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.a = gen_load(pcap_vsp[-3].i, pcap_vsp[-1].a, 1); }
break;
case 83:
#line 253 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.a = gen_load(pcap_vsp[-5].i, pcap_vsp[-3].a, pcap_vsp[-1].i); }
break;
case 84:
#line 254 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.a = gen_arth(BPF_ADD, pcap_vsp[-2].a, pcap_vsp[0].a); }
break;
case 85:
#line 255 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.a = gen_arth(BPF_SUB, pcap_vsp[-2].a, pcap_vsp[0].a); }
break;
case 86:
#line 256 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.a = gen_arth(BPF_MUL, pcap_vsp[-2].a, pcap_vsp[0].a); }
break;
case 87:
#line 257 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.a = gen_arth(BPF_DIV, pcap_vsp[-2].a, pcap_vsp[0].a); }
break;
case 88:
#line 258 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.a = gen_arth(BPF_AND, pcap_vsp[-2].a, pcap_vsp[0].a); }
break;
case 89:
#line 259 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.a = gen_arth(BPF_OR, pcap_vsp[-2].a, pcap_vsp[0].a); }
break;
case 90:
#line 260 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.a = gen_arth(BPF_LSH, pcap_vsp[-2].a, pcap_vsp[0].a); }
break;
case 91:
#line 261 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.a = gen_arth(BPF_RSH, pcap_vsp[-2].a, pcap_vsp[0].a); }
break;
case 92:
#line 262 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.a = gen_neg(pcap_vsp[0].a); }
break;
case 93:
#line 263 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.a = pcap_vsp[-1].a; }
break;
case 94:
#line 264 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.a = gen_loadlen(); }
break;
case 95:
#line 266 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = '&'; }
break;
case 96:
#line 267 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = '|'; }
break;
case 97:
#line 268 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = '<'; }
break;
case 98:
#line 269 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = '>'; }
break;
case 99:
#line 270 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = '='; }
break;
case 101:
#line 273 "/export/home/gray/ipacct/libpcap/./grammar.y"
{ pcap_val.i = pcap_vsp[-1].i; }
break;
#line 1058 "grammar.c"
    }
    pcap_ssp -= pcap_m;
    pcap_state = *pcap_ssp;
    pcap_vsp -= pcap_m;
    pcap_m = pcap_lhs[pcap_n];
    if (pcap_state == 0 && pcap_m == 0)
    {
#if YYDEBUG
        if (pcap_debug)
            printf("pcap_debug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        pcap_state = YYFINAL;
        *++pcap_ssp = YYFINAL;
        *++pcap_vsp = pcap_val;
        if (pcap_char < 0)
        {
            if ((pcap_char = pcap_lex()) < 0) pcap_char = 0;
#if YYDEBUG
            if (pcap_debug)
            {
                pcap_s = 0;
                if (pcap_char <= YYMAXTOKEN) pcap_s = pcap_name[pcap_char];
                if (!pcap_s) pcap_s = "illegal-symbol";
                printf("pcap_debug: state %d, reading %d (%s)\n",
                        YYFINAL, pcap_char, pcap_s);
            }
#endif
        }
        if (pcap_char == 0) goto pcap_accept;
        goto pcap_loop;
    }
    if ((pcap_n = pcap_gindex[pcap_m]) && (pcap_n += pcap_state) >= 0 &&
            pcap_n <= YYTABLESIZE && pcap_check[pcap_n] == pcap_state)
        pcap_state = pcap_table[pcap_n];
    else
        pcap_state = pcap_dgoto[pcap_m];
#if YYDEBUG
    if (pcap_debug)
        printf("pcap_debug: after reduction, shifting from state %d \
to state %d\n", *pcap_ssp, pcap_state);
#endif
    if (pcap_ssp >= pcap_ss + pcap_stacksize - 1)
    {
        goto pcap_overflow;
    }
    *++pcap_ssp = pcap_state;
    *++pcap_vsp = pcap_val;
    goto pcap_loop;
pcap_overflow:
    pcap_error("yacc stack overflow");
pcap_abort:
    return (1);
pcap_accept:
    return (0);
}
